<?php

namespace Drupal\Tests\homebox\Functional;

use Drupal\Tests\BrowserTestBase;

/**
 * The functional homebox test base class.
 *
 * @group homebox
 */
abstract class FunctionalHomeboxTestBase extends BrowserTestBase {

  /**
   * {@inheritdoc}
   */
  protected static $modules = [
    'homebox',
    'block',
    'serialization',
    'layout_discovery',
    'path',
    'jquery_ui',
    'test_page_test',
    'user',
  ];

  /**
   * A user with admin permissions.
   *
   * @var \Drupal\Core\Session\AccountInterface
   */
  protected $adminUser;

  /**
   * {@inheritdoc}
   */
  protected $defaultTheme = 'stark';

  /**
   * A homebox test builder instance.
   *
   * @var \Drupal\Tests\homebox\Functional\HomeboxTestHelper
   */
  protected $homeboxTestHelper;

  /**
   * {@inheritdoc}
   */
  protected function setUp(): void {
    parent::setUp();

    $this->homeboxTestHelper = new HomeboxTestHelper();

    $this->config('system.site')->set('page.front', '/test-page')->save();
    $this->adminUser = $this->drupalCreateUser([]);
    $this->adminUser->addRole($this->createAdminRole('admin', 'admin'));
    $this->adminUser->save();
    $this->drupalLogin($this->adminUser);
  }

}
